<template>
  <transition class="reviews" name="modal">
    <div>
      <div class="modal__wrapper" :class="{'addReview':addReview}" @click="closeReviews">
      </div>
      <div v-if="!addReview" class="modal-content">
        <!-- header -->
        <div class="modal-header" v-if="title">
          <span class="modal-title"> {{ title }} </span>
        </div>
        <span class="button-close" title="close" @click="closeReviews"></span>
        <!-- body -->
        <div class="modal-body">
          <p class="title">197 отзывов</p>
          <div class="reviews-container">
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="13" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="13" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="14" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="13" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="13" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="13" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
            <div class="reviews-wrap">
              <div class="reviews-profile">
                <div class="reviews-avatar">
                  <img src="../assets/images/card/img1.jpg" alt="">
                </div>
                <div class="reviews-name">
                  <div class="title">Данте Алигьери</div>
                  <Stars :size="13" :stars="4"/>
                  <div class="subtitle">5/5 баллов</div>
                </div>
              </div>
              <div class="reviews-comment">
                <p>Все круто, хорошо обработал, цены адекватные, быстро отвечает, перешло много человек.</p>
              </div>
            </div>
          </div>
          <slot name="body"></slot>
          <div class="reviews-add">
            <Button @click.native="addReview = true" small text="Оставить отзыв"/>
          </div>
        </div>
      </div>
      <div v-if="addReview" class="modal-content" :class="{'addReview':addReview}">
        <!-- header -->
        <div class="container">
          <div class="modal-header">
            <img @click="addReview = false" src="../assets/images/icons/back.svg" alt="">
            <div class="title">Оставить отзыв</div>
          </div>
          <p style="text-align: center" class="subtitle">Вы довольны работой с продавцом?</p>
          <div class="rating">
            <div class="title">Оценка</div>
            <div class="rating-stars-container">
              <Stars :size="20" :stars="0"/><span>/ 0 баллов</span>
            </div>
          </div>
          <Input textarea name="Сообщение" subtitle="максимум 500 символов" placeholder="Напишите сюдап что-нибудь интересное..." />
          <Button @click.native="showNotification" text="Отправить отзыв"/>
        </div>
        <!-- body -->
        <div class="modal-body">
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
import Button from "./Button";
import Stars from "./Stars";
import Input from "./Input";
export default {
  name: "Reviews",
  components: {Input, Stars, Button},
  data () {
    return {
      addReview: false
    }
  },
  props: {
    title: {
      type: String,
      required: false
    }
  },
  methods: {
    showNotification () {
      this.closeReviews()
      this.$root.$refs.account.notification()
    },
    closeReviews () {
      this.$emit('close')
      document.body.style.overflow = 'visible'
    }
  },
  mounted () {
    document.body.addEventListener('keyup', e => {
      if (e.key === 'Escape') this.closeReviews()
    })
  },
}
</script>

<style scoped lang="scss">
//animations
.modal-enter, .modal-leave-active {
  opacity: 0;
}
.modal-animate-leave-active {
  transition: transform .6s ease, opacity .6s;
}
.modal-enter .modal-content,
.modal-leave-active .modal-content {
  transform: translateY(320px);
}
.modal__wrapper{
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  top: 0;
  left: 0;
  height: 20vh;
  transition: opacity .2s ease;
  right: 0;
  z-index: 990;
  background-color: rgba(00,00,00,.48);
  &.addReview {
    height: 0;
  }
}
.modal-content {
  position: absolute;
  bottom: 0;
  width: 100vw;
  height: 85vh;
  background-color: #fff;
  border: 1px solid #dcdfe6;
  transition: all .2s ease;
  border-radius: 12px 12px 0 0;
  z-index: 991;
  &.addReview {
    height: 100vh;
  }
  @media screen and (min-width: 900px) {
    min-width: 500px;
  }
  .title {
    font-weight: 700;
    font-size: 18px;
    line-height: 120%;
    text-align: left;
    margin-bottom: 24px;
    padding: 40px 24px 0 24px;
  }
  .reviews-container {
    overflow-y: auto;
    overflow-x: hidden;
    max-height: calc(85vh - 88px);
    .reviews-wrap {
      border-top: 0.5px solid #C4C4C4;
      width: 100vw;
      padding: 16px 24px;
      display: flex;
      flex-direction: column;
      &:last-child {
        border-bottom: none;
      }
      .reviews-profile {
        display: flex;
        margin-bottom: 20px;
        .reviews-avatar {
          border-radius: 50%;
          overflow: hidden;
          width: 80px;
          margin-right: 16px;
          img {
            width: 100%;
          }
        }
        .reviews-name {
          display: flex;
          flex-direction: column;
          align-items: flex-start;
          .title {
            margin-bottom: 12px;
            padding: 0;
          }
          .stars {
            display: flex;
            margin-bottom: 12px;
            img {
              width: 13.33px;
            }
          }
        }
      }
      .reviews-comment {
        margin-bottom: 12px;
        text-align: left;
        font-size: 16px;
        line-height: 130%;
      }
    }
  }
  .container {
    .subtitle {
      margin-bottom: 40px;
    }
    .rating {
      margin-bottom: 40px;
      .title {
        font-size: 18px;
        line-height: 120%;
        text-align: left;
        margin-bottom: 26px;
        padding: 0;
      }
      .rating-stars-container {
        display: flex;
        align-items: center;
        span {
          margin-left: 9px;
        }
      }
    }
  }
  .reviews-add {
    position: absolute;
    bottom: 16px;
    left: 0;
    right: 0;
  }
  .modal-header {
    display: flex;
    margin-bottom: 40px;
    .title {
      margin: 0;
      margin-left: calc(50% - 115px);
      text-align: center;
      padding: 0;
      font-weight: 700;
      font-size: 24px;
      line-height: 120%;
    }
  }

}
.button-close {
  position: absolute;
  left: calc(50% - 22px);
  top: 18px;
  cursor: pointer;
  width: 44px;
  height: 5px;
  transition: all .3s;
  background: #C4C4C4;
  border-radius: 100px;
  user-select: none;
  &:hover {
    transform: scale(1.1);
  }
}
.modal-body {
  text-align: center;
  overflow: hidden;
  max-height: 100%;
  img {
    max-width: initial!important;
    border-radius: 5px;
  }
}
.modal-bottom {
  padding-top: 40px;
}
a.another-modal {
  color: #000;
  border-bottom: 1px solid #000;
}
input {
  border: initial;
  border-bottom: 1px solid #ede7e7;
  padding: 16px 13px;
  margin-bottom: 12px;
  font-size: 18px;
  background: white;
}
</style>
